#include <limits.h>
#include <errno.h>
#include "fibonacci.h"

#define UINT_MAX_FIB_N 47

unsigned int FibonacciNumbers[UINT_MAX_FIB_N];

void fibinit(void) {
  int i;

  FibonacciNumbers[0] = 0;
  FibonacciNumbers[1] = 1;

  for (i = 2; i <= UINT_MAX_FIB_N; i++) {
    FibonacciNumbers[i] = FibonacciNumbers[i-1] + FibonacciNumbers[i-2];
  }
}

unsigned int fib(unsigned int n) {
  if (n > UINT_MAX_FIB_N) {
    errno = ERANGE;
    return UINT_MAX;
  }

  return FibonacciNumbers[n];
}
