#include <math.h>
#include <errno.h>

#include "fibonacci.h"


long double fibl(unsigned int n) {
  unsigned int fn;

  errno = 0;
  fn = fib(n);
  if (errno == ERANGE) {

    const long double s5 = sqrtl(5.0);
    long double nl = (long double)n;

    errno = 0;
    return (powl((1.0+s5)*0.5, nl) + powl((1.0-s5)*0.5, nl))/s5;

  }


  return (long double)fn;

}


