#include <stdlib.h>
#include "numbertheory.h"

#define GGCD(TYPE,PREFIX) \
TYPE PREFIX ## gcd(TYPE a, TYPE b) {\
  a = PREFIX ## abs(a);\
  b = PREFIX ## abs(b);\
  if (a == 0)\
    return b;\
  if (b == 0)\
    return a;\
  do {\
    TYPE t = a % b;\
    a = b;\
    b = t;\
  } while (b);\
  return a;\
}

#define GLCM(TYPE,PREFIX) \
TYPE PREFIX ## lcm(TYPE a, TYPE b) {\
  if (a == 0 || b == 0)\
    return 0;\
  return a*(b/PREFIX ## gcd(a,b));\
}

GGCD(int,)
GLCM(int,)

GGCD(long int, l)
GLCM(long int, l)

GGCD(long long int, ll)
GLCM(long long int, ll)

